/* $Id: Ibeats2.java,v 1.16 2018/09/20 22:05:00 mit3 Exp $ :/
/* Ibeats2.java v2.0 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.text.DecimalFormat;

public class Ibeats2 extends Applet
    implements AdjustmentListener, ActionListener, ItemListener, 
	       MouseListener, MouseMotionListener, Runnable
{
    final int KB = 88;
    final int Oct = 12;
    final int Oct2 = Oct*2;
    final int Cent = 1200;
    final int MaxP = 20; // partial
    final int CENT = 0;  // graph.
    final int INHA = 1;
    final int BEAT = 2;
    final int LINE = 0;  // display
    final int DOTS = 1;
    final int IMPU = 2;
    final int OCTA = 0;  // beats
    final int KEYS = 1;
    final int FULL = 2;
    final double RevO = 1.0/Oct;
    final double Log10 = Math.log(10);
    final String[] Graph = {"Line", "Dot", "Impulse"};
    final String[] Keys = {"->", ">", ">>"};
    final String[] West = {"Cent", "Inha.", "Beat"};
    final String[] Beat = {"Oct.", "Key", "Full"};
    private final String[] Cstep = 
    {"0.001","0.01","0.05","0.1","0.5","1.0","5.0","10.0","40.0"};
    private final String[] Keynm =
    {"A","B","H","C","Cis","D","Es","E","F","Fis","G","Gis"};
    final String[] Octnm =
    {"A2","A1","A","a","a1","a2","a3","a4"};
    private static final long serialVersionUID = 1L;

    private Panel PS, PE, PN, PW;
    private Scrollbar scrW;
    private Scrollbar scrH;
    private Scrollbar sbBeat; // beat
    private Scrollbar sbGrade;
    private Button btPV;    // +
    private Button btMV;    // -
    private Button btPC;    // >
    private Button btMC;    // <
    private Button btTune;
    private Button btOcta;
    private Button btSkip;
    private Button btItype;
    private Button btCp;
    private Button btCm;
    private Button[] btWest;
    private Button[] btKeys;
    private Button btText; // TEST
    private Choice chPart;
    private Choice chInte;
    private Choice chGrap;
    private Choice chCent;
    private TextField tfA;
    private TextField tfB;
    private Label lbBeat;
    private Label lbGrade;
    private Canvas can;
    private Thread thr;

    boolean Msw;  // mouse
    boolean SKsw; // skip
    boolean Isw;  // curve|straight
    boolean Rev;  //  def:+
    boolean Pre;  // Υ def:+
    boolean ICsw; // inha-clear
    boolean TEST = false; //true|false;
    int W;
    int H;
    int W2;
    int H2;
    int H0;
    int HH;
    int Val;   // scrW
    int Ver;   // scrH
    int SelP;  // partial
    int AA = 440;
    int Key;
    int Bkey;
    int Skp;
    int Cmax = 100; // for keys
    int Cmx = 100;  // for height
    int Bmax = 10;  // beats max
    int MX;    // mouse x
    int LDI;   // grap.sw 
    int BEE;   // beats.sw
    int GRP = BEAT; // disp.sw
    int FNT;
    int Dot;
    int Dsf;   // dot/2
    int GradSave;
    double Vby = 300.0;
    double DH; // scrW
    double DY; // partial
    double DV; // beat memori
    double DC; // cent
    double DU; // beat
    double DK; // keyboard
    double DM; // cent memori
    double DO; // octave
    double OV; // beat
    double Cby;
    double[] InhaTF;
    double[] InhaTK;
    double[] BaseKey = new double[MaxP+1];
    Color[] Gc;
    String Error = "";

    TuningFormula2 TF2;
    TuningKeys2 TK2;
    Interval I;
    Graphics gi;
    Image ig;
    Font Fnt;
    FontMetrics Fm;
    DecimalFormat df1;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
        Fm = getFontMetrics(Fnt);
	df1 = new DecimalFormat("#0.0##");

	I = new Interval();
	buildLayout();
	initColor();
	initSeting();
	set_enabled();
    }
    public void buildLayout() {
	setBackground(Color.lightGray);
        setLayout(new BorderLayout());

	PN = new Panel();
        PN.setLayout(new GridLayout(2,1,0,0));
        add(PN, "North");

        Panel n1 = new Panel();
        n1.setLayout(new FlowLayout());
        PN.add(n1);

        Panel n2 = new Panel();
        n2.setLayout(new FlowLayout());
        PN.add(n2);

	tfA = new TextField(45);
        tfA.setEditable(false);
        n1.add(tfA);
	//---

        btKeys = new Button[Keys.length];
        for (int i = 0; i < Keys.length; i++) {
            btKeys[i] = new Button(Keys[i]);
            btKeys[i].addActionListener(this);
            n2.add(btKeys[i]);
        }

	chInte = new Choice();
        for (int i = 0; i < I.getInum(); i++)
            chInte.addItem(I.toString(i));
        n2.add(chInte);
        chInte.addItemListener(this);
	Skp = 1;

	chPart = new Choice();
        for (int i = 1; i <= MaxP; i++)
            chPart.addItem(""+i);
        n2.add(chPart);
        chPart.addItemListener(this);
	SelP = 1;

	n2.add(new Label("|"));

        chCent = new Choice();
        for (int i = 0; i < Cstep.length; i++)  // cent
            chCent.addItem(Cstep[i]);
        chCent.addItemListener(this);
        n2.add(chCent);
	chCent.select("1.0");
        Cby = 1.0;

        btCm = new Button("-");
        btCm.addActionListener(this);
        n2.add(btCm);

        btCp = new Button("+");
        btCp.addActionListener(this);
        n2.add(btCp);

	if (TEST) { // get text data 
	    btText = new Button("T");
	    n2.add(btText);
	    btText.addActionListener(this);
	}
	//-----north/south

	PS = new Panel();
        PS.setLayout(new GridLayout(2,1,0,0));
        add(PS, "South");

        Panel s1 = new Panel();
        s1.setLayout(new GridLayout(1,2,0,0));
        PS.add(s1);

        Panel s2 = new Panel();
        s2.setLayout(new GridLayout(1,6,0,0));
        PS.add(s2);

        scrW = new Scrollbar(Scrollbar.HORIZONTAL,50,2,1,100);
        s1.add(scrW);
        scrW.setBlockIncrement(10);
        scrW.addAdjustmentListener(this);

	scrH = new Scrollbar(Scrollbar.HORIZONTAL,100,2,1,100);
        s1.add(scrH);
        scrH.setBlockIncrement(10);
        scrH.addAdjustmentListener(this);

	btTune = new Button("Clear");
        s2.add(btTune);
        btTune.addActionListener(this);

        sbBeat = new Scrollbar(Scrollbar.HORIZONTAL,10,1,0,31);
        s2.add(sbBeat);
        sbBeat.setBlockIncrement(10);
        sbBeat.addAdjustmentListener(this);

	lbBeat = new Label("Beat:____");
        s2.add(lbBeat);

	btItype = new Button(" Curve ");
        s2.add(btItype);
        btItype.addActionListener(this);

        GradSave = 28; // Straight
        sbGrade = new Scrollbar(Scrollbar.HORIZONTAL,87,1,0,121);
        s2.add(sbGrade);
        sbGrade.addAdjustmentListener(this);

	lbGrade = new Label("Grade:_____");
        s2.add(lbGrade);
	//-----south/west

	PW = new Panel();
        PW.setLayout(new GridLayout(6,1,0,0));
        add(PW, "West");

        btWest = new Button[West.length];
        for (int i = 0; i < West.length; i++) {
            btWest[i] = new Button(West[i]);
            btWest[i].addActionListener(this);
            PW.add(btWest[i]);
        }

	btOcta = new Button("Oct.");
        PW.add(btOcta);
        btOcta.addActionListener(this);

	chGrap = new Choice();
	for (int i = 0; i < Graph.length; i++)
	    chGrap.addItem(Graph[i]);
	PW.add(chGrap);
        chGrap.addItemListener(this);

	btSkip = new Button("All");
        PW.add(btSkip);
        btSkip.addActionListener(this);
	//-----west/east

	PE = new Panel();
	PE.setLayout(new GridLayout(5,1,0,0));
        add(PE, "East");

	btPV = new Button("+");
        PE.add(btPV);
        btPV.addActionListener(this);

	btMV = new Button("-");
        PE.add(btMV);
        btMV.addActionListener(this);

	PE.add(new Label(""));

	btPC = new Button(">");
        PE.add(btPC);
        btPC.addActionListener(this);

	btMC = new Button("<");
        PE.add(btMC);
        btMC.addActionListener(this);
	//-----east/center

	can = new MyCanvas();
        add(can, "Center");

	can.addMouseListener(this);
	can.addMouseMotionListener(this);
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
	H0 = H-FNT*2;
	H2 = H0/2;
	W2 = W/2;
	HH = H/2;

	scrW.setValues(W2, 2, 0, W);
	int dh = H/MaxP;
	scrH.setValues(0, dh, 0, H0+dh);

        can.setSize(W, H);
	ig = createImage(W, H);
        gi = ig.getGraphics();
    }
    public Dimension getCanvasD() {
	Dimension dn = PN.getSize();
        Dimension ds = PS.getSize();
	Dimension de = PE.getSize();
	Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(ds.height+dn.height);
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void initSeting() {
	TF2 = new TuningFormula2();
	TK2 = new TuningKeys2(KB);

	chInte.select(I.getIinte(Oct));
	chPart.select("1");

	init_inha();
	initKeys();
    }
    public void initKeys() {
	Key = 37-1;
	Bkey = getInteKey();
	setBaseKey(Bkey);
    }
    public void init_inha() {
	InhaTF = TF2.getInha(); // ͤ饤϶
        TF2.getCurve(1.0);      // ĴΧ

        InhaTK = TK2.makeInha();
    }
    public void make_inhar() {
        if (Isw)
            InhaTK = TK2.makeInha(28, 0.55, getGrad());
        else
            InhaTF = TF2.getInharmonicity(28, 0.55, getGrad());
    }

    public void mousePressed(MouseEvent m) {
	Msw = !Msw;

	if (!Msw)
	    resetError();

	can.repaint();
    }
    public void mouseClicked(MouseEvent m) {}
    public void mouseReleased(MouseEvent m) {}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited(MouseEvent m) {}
    public void mouseMoved(MouseEvent me) {
	if (!Msw) {
	    MX = me.getX();
	    mouse_check();

	    can.repaint();
	}
    }
    public void mouse_check() {
	if (GRP == BEAT && (BEE == OCTA || BEE == KEYS))
	    return;

	int max = KB, min = 0;
	Key = (int)(MX/DK);
	int[] id = I.getIdata(getInteIndex());
	max = getMaxIntv(id[2], KB);
	min = getMinIntv(id[2], 0);

	if (Key < min)
	    Key = min;
	if (Key >= max)
	    Key = max-1;

	Bkey = getInteKey();
    }
    public void mouseDragged(MouseEvent me) { }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        can.repaint();
    }
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == btPV)
	    setValue(true);
	else if (e.getSource() == btMV)
	    setValue(false);

	else if (e.getSource() == btPC)
	    setCmax(true);
	else if (e.getSource() == btMC)
	    setCmax(false);

	else if (e.getSource() == btWest[CENT])
	    GRP = CENT;
	else if (e.getSource() == btWest[INHA])
	    GRP = INHA;
	else if (e.getSource() == btWest[BEAT])
	    GRP = BEAT;
	else if (e.getSource() == btOcta)
	    changeOctave();
	else if (e.getSource() == btSkip)
	    changeSkip();

	else if (e.getSource() == btTune)
	    startRun();

	else if (e.getSource() == btKeys[0])
	    reversKey();
	else if (e.getSource() == btKeys[1])
	    changeKey(1);
	else if (e.getSource() == btKeys[2])
	    changeKey(Oct);

	else if (e.getSource() == btItype)
	    set_itype();

	else if (e.getSource() == btCm)
	    pm_cent(false);
	else if (e.getSource() == btCp)
	    pm_cent(true);

	else if (e.getSource() == btText) // for TEST
	    textOutput();

	set_enabled();
	can.repaint();
    }
    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == chPart)
	    setPartial();

	if (e.getSource() == chInte)
	    setInterval();

	if (e.getSource() == chGrap)
	    setGraph();

	if (e.getSource() == chCent)
	    setCent();

	can.repaint();
    }
    public void set_enabled() {
	boolean bsw = (GRP == BEAT);
	btOcta.setEnabled(bsw);
	boolean sch = (BEE != FULL & bsw);
	scrH.setEnabled(sch);

	boolean osw = (BEE == KEYS & bsw);
	btSkip.setEnabled(osw);
	scrW.setEnabled(osw);
	btPC.setEnabled(osw);
	btMC.setEnabled(osw);
	chGrap.setEnabled(osw);

	boolean isw = (GRP != INHA);
	btPV.setEnabled(isw);
	btMV.setEnabled(isw);
    }
    public void pm_cent(boolean sw) {
	double ce = sw ? Cby : -Cby;

	add_cent(Key, ce);
    }
    public void setCent() {
	String hn = chCent.getSelectedItem();
	Cby = Double.valueOf(hn).doubleValue();
    }
    public void set_itype() {
	int tmp = sbGrade.getValue();

        Isw = !Isw;
        btItype.setLabel(Isw ? "Straight" : " Curve ");

        sbGrade.setMinimum(Isw ? 10 : 0);   // 1 | 0.0
        sbGrade.setMaximum(Isw ? 42 : 121); // 4.1 | 0.12

        sbGrade.setValue(GradSave);
        GradSave = tmp;
    }
    public double getGrad() {
        return Isw ? sbGrade.getValue()/10.0 : sbGrade.getValue()/1000.0;
    }
    public void startRun() {
	ICsw = !ICsw;

	if (ICsw) {
	    init_cent();
	} else {
	    make_inhar();

	    if (Isw) {
		TK2.startRun(OV, 28, 0.55, getGrad()); // 

		thr = new Thread(this);
		thr.start();
	    } else {
		TF2.getCurve(OV);
		can.repaint();   
	    }
	}

	btTune.setLabel(ICsw ? "Tune" : "Clear");
    }
    public void run() {
	int stime = 80;   // sleep time
	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
	btTune.setEnabled(false);

	try {
	    while (TK2.isRun()) {
		can.repaint();
		Thread.sleep(stime); //thr.sleep(stime);
            }
        } catch (InterruptedException e) {
            System.out.println(e);
        }

	thr = null; //
	btTune.setEnabled(true);
	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	can.repaint();
    }
    //
    public void set_cent(int key, double ce) {
	if (Isw)
            TK2.setCent(key, ce);
        else
            TF2.setCent(key, ce);
    }
    public void add_cent(int key, double ce) {
	if (Isw)
            TK2.addCent(key, ce);
        else
            TF2.addCent(key, ce);
    }
    public String getKeynm(int k) {
	return (k+1)+"("+getKey(k)+") "+
	    dform(getIfreq(k, 1))+"[Hz]";
    }
    public String getKey(int k) {
	return (k < 0) ? "" : Keynm[k%Oct];
    }
    //---

    public void textOutput() {
	int csft = Cmax/2, is;

	switch (LDI) {
	case DOTS:
	case LINE: // for line
	    for (int j = Skp; j <= SelP; j++) {
		if (j%Skp != 0)
		    continue;

		for (int i = 0; i <= Cmax; i++) {
		    is = i-csft;
		    System.out.println(is+" "+dform(getBeats(j, is)));
		}
	    }
	    break;
	case IMPU: // for impulse
	    for (int i = 0; i <= Cmax; i++) {
		is = i-csft;
		for (int j = Skp; j <= SelP; j++) {
		    if (j%Skp != 0)
			continue;

		    System.out.println(is+" "+
				       dform(getIfreq(Key, j, is))+" "+
                                       dform(getBeats(j, is)));
		}
		System.out.println();
	    }
	    break;
	default:
	}
    }

    public void write_tfa() {
	if (!Error.equals(""))
	    tfA.setText(Error);
	else {
	    StringBuffer sb = new StringBuffer(48);

	    switch (GRP) {
	    case BEAT:
		switch (BEE) {
		case KEYS:
		    sb.append(getKeynm(Key));
		    double ce = getCent();
		    double b = getBeats(Key, Skp, ce);
		    sb.append(": "+dform(ce)+"[cent]: ");
		    sb.append(dform(b)+"("+Skp+")");
		    break;
		case FULL:
		    sb.append(getKeynm(Key));
		    int[] id = I.getIdata(getInteIndex());
		    int max = getMaxIntv(id[2], KB);
		    int min = getMinIntv(id[2], 0);
		    if (Key >= min && Key < max) {
			double be = get_full_beats(Key, id, 1);
			sb.append(": "+dform(be));
		    }
		    break;
		default:
		}
		break;
	    case CENT:
		sb.append(getKeynm(Key)+": ");
		sb.append(dform(getCent(Key))+"[cent]");
		break;
	    case INHA:
		sb.append(getKeynm(Key)+": ");
		sb.append(dform(getInha(Key)));
		break;
	    default:
	    }

	    sb.append(Rev ? "=>" : "<=");
	    sb.append((Bkey >= 0 && Bkey < KB) ?
		      getKeynm(Bkey) : "...");

	    tfA.setText(sb.toString());
	}
    }
    public void init_cent() {
	for (int i = 0; i < KB; i++)
	    set_cent(i, 0);
    }
    public int getInterval() {
	return I.getIvalue(getInteIndex());
    }
    public int getInteIndex() {
	return chInte.getSelectedIndex();
    }
    public int getInteKey() {
	return Rev ? Key+getInterval() : Key-getInterval();
    }
    public void reversKey() {
	Rev = !Rev;

        btKeys[0].setLabel(Rev ? "<-" : "->");
        btKeys[1].setLabel(Rev ? "<" : ">");
        btKeys[2].setLabel(Rev ? "<<" : ">>");

        Key = Rev ? Key-getInterval() : Key+getInterval();
        Pre = Rev;
	Bkey = getInteKey();
	set_skip_base();
    }
    public void changeKey(int val) {
	int max = KB-1;
	int min = 0;
	Key += Rev ? -val : val;

        if (Key < min)
            Key = min;
        else if (Key > max)
            Key = max;

	Bkey = getInteKey();
	set_skip_base();
    }
    public void set_skip_base() {
        setSkip();
        setBaseKey(Bkey);
    }
    public int getMaxIntv(int itv, int max) {
	return Rev ? max-itv : max;
    }
    public int getMinIntv(int itv, int min) {
	return Rev ? min : min+itv;
    }
    public void setError(String er) {
	Error = er;
	Msw = true;
    }
    public void resetError() {
	Error = "";
	Msw = false;
    }
    public void changeSkip() {
	SKsw = !SKsw;
	btSkip.setLabel(SKsw ? "Skip" : "All");

	setInterval();
    }
    public void changeOctave() {
	BEE += 1;

	if (BEE > 2)
	    BEE = 0;
	btOcta.setLabel(Beat[BEE]);
    }
    public int getCent() {
	return getMcent()-Cmax/2;
    }
    public int getMcent() {
	return (int)(MX/DC);
    }
    public void setGraph() {
	LDI = chGrap.getSelectedIndex();
    }
    public void setCmax(boolean sw) {
	int cmax = 100;
	int cmin = 20;
	Cmax = sw ? Cmax+cmin : Cmax-cmin;

	if (Cmax < cmin)
	    Cmax = cmin;
	else if (Cmax > cmax)
	    Cmax = cmax;
    }
    public void setInterval() {
	int max = KB-1;
	int min = 0;
	int itv = getInterval();

	if (!Rev && (Key-itv < min))
            Key = itv+min;
        else if (Rev && (Key+itv > max))
            Key = max-itv;

	Bkey = getInteKey();
	set_skip_base();
    }
    public void setSkip() {
        int in = getInteIndex();

	Skp = SKsw ? (Rev ? I.getIlow(in) : I.getIhigh(in)) : 1;
    }
    public void setPartial() {
	String sp = chPart.getSelectedItem();
	SelP = Integer.parseInt(sp);
    }
    public void setValue(boolean sw) {
      	switch(GRP) {
	case BEAT:
	    if (BEE != FULL)
		Vby = sw ? Vby/Math.sqrt(2) : Vby*Math.sqrt(2);
	    else
		Bmax = limit_Value(Bmax, 800, 10, sw); // 5+5=10
	    break;
	case CENT:
	    Cmx = limit_Value(Cmx, 200, 10, sw);
	    break;
	case INHA:
	    break;
	default:
	}
    }
    public int limit_Value(int val, int max, int min, boolean sw) {
	val = sw ? val*2 : val/2;

	if (val > max)
	    val = max;
	if (val > 26 && val < 50)
	    val = 50;
	if (val < 26 && val > 10)
	    val = 20;
	if (val < min)
	    val = min;

	return val;
    }
    public double getBeats(int p, double ce) {
	double be, f2 = getIfreq(Key, p, ce);
	double min = Double.MAX_VALUE;

	for (int i = 1; i <= SelP; i++) {
	    be = f2-BaseKey[i];
	    min = Math.min(Math.abs(be), Math.abs(min));
	}
	return min;
    }
    public double getBeats(int key, int p, double ce) {
	double be, f2, min = Double.MAX_VALUE;

	for (int j = 1; j <= p; j++) {
	    f2 = getIfreq(key, j, ce);
	    for (int i = 1; i <= p; i++) {
		be = f2-BaseKey[i];
		min = Math.min(Math.abs(be), Math.abs(min));
	    }
	}
	return min;
    }
    public double getIfreq(int key, int p) {
	return Isw ? TK2.getIfreq(key, p) : TF2.get_ifreq(key, p);
    }
    public double getIfreq(int key, int p, double ce) {
	return ctof(getIfreq(key, p), ce);
    }
    public double getInha(int key) {
	return Isw ? InhaTK[key] : InhaTF[key];
    }
    public double getCent(int key) {
	return Isw ? TK2.getCent(key) : TF2.get_cent(key);
    }
    public double log_base(double value) {
        return Math.log(value)/Log10;
    }
    public String dform(double nm) {
        return df1.format((float)nm);
    }
    public double ctof(double f, double c) {
	return f*Math.pow(2, c/Cent);
    }
    public void setBaseKey(int key) {
	for (int i = 1; i <= SelP; i++) {
	    BaseKey[i] = getIfreq(key, i, 0);
	}
    }
    public void initColor() {
	Gc = new Color[MaxP];
	double dc = 1.0/MaxP;
        float c0, sft = 0.0f;

        for (int i = 0; i < MaxP; i++) {
            c0 = (float)(dc*i+sft);
            if (c0 > 1.0)
                c0 -= 1.0;
            Gc[i] = Color.getHSBColor(c0, 1.0f, 1.0f);
        }
    }
    //----

    class MyCanvas extends Canvas {
	private static final long serialVersionUID = 1L;
        public void update(Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void paintI() {
        gi.setColor(Color.black);
        gi.fillRect(0, 0, W, H);

	Val = scrW.getValue();
	DH = (double)(W2-Val)/MaxP;
	Ver = scrH.getValue();
	DY = (double)(H0-Ver)/MaxP;
	DV = (H0-1)/Vby;
	DC = (double)(W-1)/Cmax;
	DK = (double)(W-1)/KB;
	setDot();
	DM = (double)(H-1)/Cmx;
	DO = (double)(W-1)/Cent;
	DU = (double)(H-1)/Bmax; // for full
	setBlavel();
	setGlavel();

	switch (GRP) {
	case BEAT:
	    switch (BEE) {
	    case OCTA: 
		disp_octave(gi);
		break;
	    case KEYS:
		disp_beats(gi);
		break;
	    case FULL:
		disp_full(gi);
		break;
	    default:
	    }
	    break;
	case CENT:
	    disp_cent(gi);
	    break;
	case INHA:
	    disp_inha(gi);
	    break;
	default:
	}
	write_tfa();

	if (thr != null)
	    disp_tuning(gi);
    }

    public void setDot() {
	Dot = FNT/3;
        int dw = (int)(W/(double)KB);
        while (Dot > dw) {
            Dot--;
        }
	if (Dot < 2)
            Dot = 2;

	Dsf = Dot/2;
    }
    public void setBlavel() {
	OV = sbBeat.getValue()/10.0;
	lbBeat.setText("Beat:"+OV);
    }
    public void setGlavel() {
	lbGrade.setText("Grade:"+getGrad());
    }
    public void disp_error(Graphics g, String text) {
	Rectangle r = getRect(text);

	g.setColor(Color.gray);
        g.fill3DRect(r.x-2, r.y-r.height, r.width+4, r.height+4, false);

        g.setColor(Color.red);
        g.drawString(text, r.x, r.y-2);
    }
    public void disp_tuning(Graphics g) {
	String text = "Now tuning...";
	Rectangle r = getRect(text);

        g.setColor(Color.gray);
        g.fill3DRect(r.x-2, r.y-r.height, r.width+4, r.height+4, false);

        g.setColor(Color.cyan);
        g.drawString(text, r.x, r.y-2);
    }
    public Rectangle getRect(String text) {
	int h = Fm.getHeight();
	int w = Fm.stringWidth(text);
	int x = (W-w)/2;
	int y = h*2;
	Rectangle rect = new Rectangle(x, y, w, h);
	
	return rect;
    }
    public Color mouse_color(int key, Color wc) {
	Color co = wc;

	if (key == Key)
	    co = Color.green;
	else if (key == Bkey)
	    co = Color.magenta;

	return co;
    }
    public void disp_inha(Graphics g) {
	int hb = H/6;
	disp_aline(g);
	disp_log(g, hb);

	int wn, max = KB;
	Color wc = Color.white;
	for (int i = 0; i < max; i++) {
	    g.setColor(mouse_color(i, wc));
	    g.fillOval((int)(i*DK), (int)(HH-log_base(getInha(i))*hb-Dsf),
		       Dot, Dot);
	}
    }
    public void disp_log(Graphics g, int hb) {
        double h0 = 0.001, hl;
        int hm;

        for (int i = 1; i < 6; i++) { // ʿ
            hl = h0*Math.pow(10, i);
            hm = (int)(HH-hb*log_base(hl));

            g.setColor(Color.blue);
            g.drawLine(0, hm, W-1, hm);

            g.setColor(Color.orange); // 
            g.drawString(""+(float)hl, 2, hm);
        }
    }
    //---

    public void disp_cent(Graphics g) {
	disp_aline(g);
	disp_cline(g);

	int wn, max = KB;
	Color wc = Color.white;
	for (int i = 0; i < max; i++) {
	    g.setColor(mouse_color(i, wc));
	    g.fillOval((int)(i*DK), (int)(HH-getCent(i)*DM-Dsf), Dot, Dot);
	}
    }
    public void disp_cline(Graphics g) {
	int hx = Cmx;
	disp_horizontal_line(g, hx, DM);
    }
    public void disp_horizontal_line(Graphics g, int hx, double dy) {
	int dh, hp, hm, xs = 2;
	double hy;

	g.setColor(Color.gray);
	g.drawLine(0, HH, W, HH);

	for (int i = 1; i < 6; i++) {
	    dh = hx*i/10;
	    hy = dy*dh;
	    hp = (int)(HH+hy);
            hm = (int)(HH-hy);

	    g.setColor(Color.blue);
	    g.drawLine(0, hm, W-1, hm);
	    g.drawLine(0, hp, W-1, hp);

	    g.setColor(Color.yellow);
            g.drawString(""+dh, xs+2, hm+FNT);
            g.drawString("-"+dh, xs, hp);
	}
    }
    public void disp_aline(Graphics g) {
        int wi;
     
	for (int i = 0; i < KB; i++) {
	    if (i%Oct == 0) {  // akeyľ
                wi = (int)(DK*i+Dsf);

                g.setColor(Color.blue);
                g.drawLine(wi, 0, wi, H);

                g.setColor(Color.red); // octave name
		g.drawString(Octnm[i/Oct], wi, H-FNT);
            }
        }
    }
    //---

    public void disp_bar(Graphics g, int cnt, double dx) {
	int ix, ic;

	g.setColor(Color.gray);
	for (int i = 0; i <= Cmax; i++) {
	    ic = (int)(i*DC);

	    g.drawLine(ic, H0, ic, H0+5);
	}

	g.setColor(Color.lightGray);
	for (int i = 0; i <= cnt; i++) {
	    ix = (int)(i*dx);

	    g.drawLine(ix, H0, ix, H0+10);
	}
    }
    public void disp_lavel(Graphics g, int cnt, double dx) {
	int ii, ix, c2 = Cmax/2;

	g.setColor(Color.pink);
	for (int i = 0; i < cnt/2; i++) {
	    ii = c2-i*10;
	    ix = (int)(i*dx);

	    g.drawString("-"+ii, ix, H);
	    g.drawString(""+ii, W-ix-FNT, H);
	}
	g.drawString("0", W2-FNT/3, H);
    }
    public void disp_memori(Graphics g) {
	int ml, dh;

	for (int i = 0; i < Vby; i++) {
	    if (i%1000 == 0) {
                ml = 15;
                g.setColor(Color.lightGray);
            } else if (i%100 == 0 && Vby < 10000) {
                ml = 13;
                g.setColor(Color.white);
            } else if (i%10 == 0 && Vby < 2000) {
                ml = 10;
                g.setColor(Color.lightGray);
            } else if (i%5 == 0 && Vby < 500) {
                ml = 7;
                g.setColor(Color.lightGray);
            } else if (Vby < 100) {
		ml = 5;
		g.setColor(Color.gray);
	    } else
		continue;
	    
	    dh = (int)(H0-i*DV);
	    g.drawLine(1, dh, ml, dh);
	}
    }
    public void disp_mark(Graphics g) {
	g.setColor(Color.lightGray); // ޡ
	g.drawLine(W2, 1, W2, 4);
	g.drawLine(Val, 1, Val, 4);
    }
    public void disp_line(Graphics g) {
	int ix, cx = Cmax/10;
	int cc = cx/2;
	double dw = DC*10;

	disp_mark(g);

	for (int i = 0; i <= cx; i++) {  // 
	    g.setColor((i == cc) ? Color.lightGray : Color.darkGray);
	    ix = (int)(dw*i);
	    g.drawLine(ix+(Val-W2), Ver, ix, H0);
	}

	disp_bar(g, cx, dw);
	disp_lavel(g, cx, dw);
    }   
    public void disp_full(Graphics g) {
	disp_full_line(g);

	int nw, wn;
	int[] id = I.getIdata(getInteIndex()); // low,high,interval
	int max = getMaxIntv(id[2], KB);
	int min = getMinIntv(id[2], 0);

	Color nc;
	for (int j = 1; j <= SelP; j++) {
	    if (id[0]*j > SelP) // ܿ
		break;

	    nc = get_full_color(id, j); // ܲο
	    for (int i = min; i < max; i++)
		disp_full_sub(g, i, j, id, nc);
	}
    }
    public void disp_full_sub(Graphics g, int k, int p, int[] id, Color c) {
	int h = (int)(HH-get_full_beats(k, id, p)*DU-Dsf);

	g.setColor((Key == k) ? Color.white : c);
	g.fillOval((int)(DK*k), h, Dot, Dot);
    }
    public Color get_full_color(int[] id, int pe) {
	int c = Rev ? id[0]*pe : id[1]*pe; // ܲ

	return Gc[c-1];
    }
    public double get_full_beats(int k, int[] id, int pe) {
	if (Rev)  // ǥκѲ
	    return getIfreq(k, id[0]*pe)-
		getIfreq(k+id[2], id[1]*pe);
	else
	    return getIfreq(k, id[1]*pe)-
		getIfreq(k-id[2], id[0]*pe);
    }
    public void disp_full_line(Graphics g) {
	int hx = Bmax;
	disp_horizontal_line(g, hx, DU); 
	disp_aline(g);
    }
    public void disp_hline(Graphics g) {
	int ys, sh;

	g.setColor(Color.darkGray);
	for (int j = 1; j <= MaxP; j++) { // 
	    ys = (int)(H0-DY*(j-1));
	    sh = (int)(DH*(j-1));

	    g.drawLine(-sh, ys, W-sh, ys);
	}
    }
    public void disp_oline(Graphics g, int from, int too, int min) {
	int dx, ii, inte = getInterval();
	//int kk = Rev ? inte : Oct-inte;
	int kk = Rev ? Oct-inte : inte;
	if (too < min+Oct)
	    kk = too-(inte+min);

	for (int i = 0; i <= Oct; i++) {
	    ii = i+from;
	    //if (ii > too)
	    //break;
	    dx = (int)(i*DO*100);

	    g.setColor((kk == i) ? Color.lightGray : Color.gray);
	    g.drawLine(dx, 0, dx, H);

	    g.setColor(Color.pink);
	    g.drawString(getKey(from+i), dx, H);
	}
	g.drawLine(0, H0, W, H0);
    }
    public void disp_octave(Graphics g) {
        int max = KB-1;
	int min = 0;
	int from = Rev ? Key : Key-Oct;
	if (from < min)
	    from = min;
	int too = Rev ? Key+Oct : Key;
	if (too > max)
	    too = max;

	disp_oline(g, from, too, min);
	disp_hline(g);
	setBaseKey(Rev ? too : from);

	int x0, y0, ys, k2 = from;
	for (int k = 1; k <= SelP; k++) {
	    ys = (int)(H0-DY*(k-1));
	    g.setColor(Gc[k-1]);

	    for (int j = 0; j <= Cent; j++) {
		y0 = (int)(ys-getBeats(k2, k, j)*DV);
		x0 = (int)(j*DO);

		g.fillOval(x0, y0, Dot, Dot);
	    }
	}
    }
    public void disp_beats(Graphics g) {
	disp_line(g);
	disp_hline(g);
	disp_memori(g);

	setBaseKey(Bkey);
	int csft = Cmax/2;
	int pt, ix, x0, y0, x1 = 0, y1 = 0;
	int cc = getMcent();
	double ys, sh, fr;
	Color cur = Color.white;

	for (int j = SelP; j >= Skp; j--) {
	    if (j%Skp != 0)
		continue;

	    ys = H0-DY*(j-1);
	    sh = DH*(j-1);

	    for (int i = 0; i <= Cmax; i+=1) {
		pt = (int)(ys-getBeats(j, i-csft)*DV);
		if (pt < -50) // 1.1.8overɽб?
		    pt = -50;
		ix = (int)(DC*i-sh);

		switch (LDI) {
		case LINE: // line+dot
		    g.setColor(Gc[j-1]);
		    x0 = ix;
		    y0 = pt;
		    if (i == 0) {
			x1 = x0;
			y1 = y0;
		    }
		    g.drawLine(x0, y0, x1, y1);
		    x1 = x0;
		    y1 = y0;
		case DOTS:
		    g.setColor((cc == i) ? cur : Gc[j-1]);
		    break;
		case IMPU: // impulse
		    g.setColor((cc == i) ? cur : Gc[j-1]);
		    g.drawLine(ix, pt, ix, (int)ys);
		    break;
		default:
		}
		g.fillRect(ix-Dsf, pt-Dsf, Dot, Dot);
	    }
	}
    }
}
