/* $Id: TuningKeys2.java,v 1.2 2013/02/05 23:26:08 mit Exp $
/* TuningKeys2.java v0.1.1 */

public class TuningKeys2 implements Runnable
{
    private boolean Runsw;
    private int KB = 88;  // max(¾?)
    private int Wend = 28;
    private int Pitch = 440;
    private int Oct2;
    private int A37;
    private int A49;
    private int A61;
    private double Ainh = 0.55;
    private double Grade = 2.8;
    private double Beat = 1.0;
    private double[] Keyc;
    private Thread thr;
    private Interval I = new Interval();

    final static int OCT = 12;
    final static int OCT2 = OCT*2;

    public TuningKeys2(int mk) {
	KB = mk;
	Keyc = new double[KB];
        Oct2 = I.getIinte(OCT2); // 27
        A37 = 37-1;
	A49 = 49-1;
        A61 = 61-1;
    }
    public void setWend(int we) {
	Wend = we;
    }
    public void setAinh(double ai) {
	Ainh = ai;
    }
    public void setGrade(double gr) {
	Grade = gr;
    }
    public void setAllCent(double[] ce) {
	Keyc = ce;
    }
    //
    public void startRun(double be, int we, double ac, double gr) {
	Beat = be;
	Wend = we;
	Ainh = ac;
	Grade = gr;

	thr = new Thread(this);
        thr.start();
        Runsw = true;
    }
    public boolean isRun() {
        return Runsw;
    }
    public void run() {
        int stime = 10;     // ꡼׻

        try {
            double sa = get_cent_val();
            set_2octave(sa/OCT2, sa/2);

            for (int i = A61+1; i < KB; i++) {
		tuning(i, Oct2, true);
                thr.sleep(stime);
            }
            for (int i = A37-1; i >= 0; i--) {
		tuning(i, Oct2, false);
                thr.sleep(stime);
           }
        } catch (InterruptedException e) {
            System.out.println(e);
        }

	Runsw = false;
    }
    public void stop() {
        if (thr != null)
            thr = null;
    }
    public double get_cent_val() {
        int k38 = 38-1;  // 2octave+1keycentФ
        int k62 = 62-1;
        Inter k2 = new Inter(k38, k62, Oct2);

        int k36 = 36-1;  // 2octave-1keycent
        int k60 = 60-1;
        Inter k1 = new Inter(k36, k60, Oct2);

        double dc = 0.01;             // ѹ
        double up = 0, ds, sa, sb, d;
        do {
            ds = up/OCT2;
            set_2octave(ds, up/2);          // Ф
	    tuneBeat(true, k2);             // +1keytune
            sa = getCent(k62)-getCent(A61); // +1key2octaveüκ

	    tuneBeat(false, k1);            // -1keytune
            sb = getCent(A37)-getCent(k36); // -1key2octaveüκ

	    d = (sa-ds > 0.6) ? dc*10 : dc;
            up += d;
	} while (sa > ds && sb > ds);       // +1-1ɤ餫κ

	return up-d;                        // 1äset_2octaveԤ
    }
    public void set_2octave(double ds, double sf) {
        double a49d = getCent(A49);

	for (int i = 0; i <= OCT2; i++)
            key_set(a49d, A37+i, ds*i-sf);
    }
    public void tuning(int k, int in, boolean sw) {
        int nx = nextKey(k, (sw ? -I.getIvalue(in) : I.getIvalue(in)));
        if (nx < 0 || nx >= KB)
            return;

	Inter In = sw ? new Inter(nx, k, in) : new Inter(k, nx, in);  
	tuneBeat(sw, In);
    }
    public void key_set(double c49, int k, double dt) {
        setCent(k, c49);   // 濴ͥ˥å
        addCent(k, dt);    // θ糧
    }
    public int nextKey(int nowkey, int itr) {
        return nowkey+itr;
    }
    public double tuneBeat(boolean sw, Inter k) {
        double mc = getBeats(k);
	double d, dc = 0.01;
	int kn;

        if (sw) {
            kn = k.getHkey();
            dc = dc;
        } else {
            kn = k.getLkey();
            dc = -dc;
        }

        double sa = 0.4;
        while (mc < Beat) {   // first
	    d = (Beat-mc > sa) ? dc*10 : dc;
            addCent(kn, d);
            mc = getBeats(k);
        }
        while (mc > Beat) {   // second
	    d = (Beat-mc > sa) ? dc*10 : dc;
	    addCent(kn, -d);
            mc = getBeats(k);
        }

        return mc;
    }
    public double getBeats(Inter n) {
        return getIfreq(n.getHkey(), n.getLint())-
            getIfreq(n.getLkey(), n.getHint());
    }
    //
    public double[] makeInha(int ww, double a49, double gra) {
	Wend = ww;
	Ainh = a49;
	Grade = gra;

	return makeInha();
    }
    public double[] makeInha() {
	int vkey;
	double[] inha = new double[KB];

	for (int i = 0; i < KB; i++) {
	    vkey = (i <= Wend) ? 2*(Wend+1)-48-i : i-48;
	    inha[i] = Ainh*Math.pow(Grade, vkey/(double)OCT);
	}

	return inha;
    }
    public double get_inha(int key) {
	int vkey = (key <= Wend) ? 2*(Wend+1)-48-key : key-48;
	return Ainh*Math.pow(Grade, vkey/(double)OCT);
    }
    public double getInha(int key, int pr) {
	return pr*pr*get_inha(key);
    }
    public double getIfreq(int key, int pr, double ce) {
	return ctof(getFreq(key)*pr, getIcent(key, pr)+ce);
    }
    public double getIfreq(int key, int pr) {
	return ctof(getFreq(key)*pr, getIcent(key, pr));
    }
    public double getFreq(int key) {
        return Pitch*Math.pow(2,(key-48)/(double)OCT); //49-1
    }
    public double getIcent(int kn, int pr) {
        return getInha(kn, pr)+getCent(kn);
    }
    public double getCent(int key) {
	return Keyc[key];
    }
    public void setCent(int key, double ce) {
	Keyc[key] = ce;
    }
    public void addCent(int key, double ce) {
	Keyc[key] += ce;
    }
    public double ctof(double f, double c) {
	return f*Math.pow(2, c/1200);
    }
}